# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`pe_status_check`](#pe_status_check): This class should be enabled if you wish Puppet to notify when pe_status_check indicators are not at optimal values
* [`pe_status_check::agent_status_enable`](#pe_status_check--agent_status_enable): Enables the execution of agent_status_check fact

### Plans

* [`pe_status_check::agent_state_summary`](#pe_status_check--agent_state_summary): provides an overview of all Puppet agents and their error states
* [`pe_status_check::agent_summary`](#pe_status_check--agent_summary): Summary report of the state of agent_status_check on each node
Uses the facts task to get the current status from each node
and produces a summary report in JSON
* [`pe_status_check::infra_role_summary`](#pe_status_check--infra_role_summary): provides an overview of all *PE* systems and their role
* [`pe_status_check::infra_summary`](#pe_status_check--infra_summary): Summary report if the state of pe_status check on each node
Uses the facts task to get the current status from each node
and produces a summary report in JSON

## Classes

### <a name="pe_status_check"></a>`pe_status_check`

When this class is enabled, when any of the indicators in the pe_status_check fact are false puppet will notify of this,
 individual tests can be disabled by adding the ID to the indicator_exclusions parameter

#### Examples

##### 

```puppet
include pe_status_check
```

#### Parameters

The following parameters are available in the `pe_status_check` class:

* [`indicator_exclusions`](#-pe_status_check--indicator_exclusions)
* [`checks`](#-pe_status_check--checks)

##### <a name="-pe_status_check--indicator_exclusions"></a>`indicator_exclusions`

Data type: `Array[String[1]]`

List of disabled indicators, place any indicator ids you do not wish to report on in this list

Default value: `[]`

##### <a name="-pe_status_check--checks"></a>`checks`

Data type: `Hash`

Hash containing a descriptiong for each key indicator

### <a name="pe_status_check--agent_status_enable"></a>`pe_status_check::agent_status_enable`

Adding this class will enable the execution of the agent_status_check fact,
This allows the fact to be targeted to a specific agent or group of agents

#### Examples

##### 

```puppet
include pe_status_check::agent_status_enable
```

#### Parameters

The following parameters are available in the `pe_status_check::agent_status_enable` class:

* [`agent_status_enabled`](#-pe_status_check--agent_status_enable--agent_status_enabled)

##### <a name="-pe_status_check--agent_status_enable--agent_status_enabled"></a>`agent_status_enabled`

Data type: `Boolean`

Flag to enable or disable agent_status_check fact

Default value: `true`

## Plans

### <a name="pe_status_check--agent_state_summary"></a>`pe_status_check::agent_state_summary`

provides an overview of all Puppet agents and their error states

#### Parameters

The following parameters are available in the `pe_status_check::agent_state_summary` plan:

* [`runinterval`](#-pe_status_check--agent_state_summary--runinterval)
* [`log_healthy_nodes`](#-pe_status_check--agent_state_summary--log_healthy_nodes)
* [`log_unhealthy_nodes`](#-pe_status_check--agent_state_summary--log_unhealthy_nodes)

##### <a name="-pe_status_check--agent_state_summary--runinterval"></a>`runinterval`

Data type: `Integer[0]`

the runinterval for the Puppet Agent in minutes. We consider latest reports that are older than runinterval as unresponsive

Default value: `30`

##### <a name="-pe_status_check--agent_state_summary--log_healthy_nodes"></a>`log_healthy_nodes`

Data type: `Boolean`

optionally return all healthy nodes, not only the unhealthy

Default value: `false`

##### <a name="-pe_status_check--agent_state_summary--log_unhealthy_nodes"></a>`log_unhealthy_nodes`

Data type: `Boolean`

optionally hide unhealthy nodes

Default value: `true`

### <a name="pe_status_check--agent_summary"></a>`pe_status_check::agent_summary`

Summary report of the state of agent_status_check on each node
Uses the facts task to get the current status from each node
and produces a summary report in JSON

#### Parameters

The following parameters are available in the `pe_status_check::agent_summary` plan:

* [`targets`](#-pe_status_check--agent_summary--targets)
* [`indicator_exclusions`](#-pe_status_check--agent_summary--indicator_exclusions)

##### <a name="-pe_status_check--agent_summary--targets"></a>`targets`

Data type: `Optional[TargetSpec]`

A comma seprated list of FQDN's of Puppet agent nodes
Defaults to using a PuppetDB query to identify nodes

Default value: `undef`

##### <a name="-pe_status_check--agent_summary--indicator_exclusions"></a>`indicator_exclusions`

Data type: `Array[String[1]]`

List of disabled indicators, place any indicator ids you do not wish to report on in this list
Static Hiera Data can be used to set indicator_exclusions in a plan - for more information see https://www.puppet.com/docs/pe/latest/writing_plans_in_puppet_language_pe.html#using_hiera_with_plans

Default value: `lookup('pe_status_check::indicator_exclusions', undef, undef, [])`

### <a name="pe_status_check--infra_role_summary"></a>`pe_status_check::infra_role_summary`

provides an overview of all *PE* systems and their role

### <a name="pe_status_check--infra_summary"></a>`pe_status_check::infra_summary`

Summary report if the state of pe_status check on each node
Uses the facts task to get the current status from each node
and produces a summary report in JSON

#### Parameters

The following parameters are available in the `pe_status_check::infra_summary` plan:

* [`targets`](#-pe_status_check--infra_summary--targets)
* [`indicator_exclusions`](#-pe_status_check--infra_summary--indicator_exclusions)

##### <a name="-pe_status_check--infra_summary--targets"></a>`targets`

Data type: `Optional[TargetSpec]`

A comma seprated list of FQDN's of Puppet infrastructure agent nodes
Defaults to using a PuppetDB query to identify nodes

Default value: `undef`

##### <a name="-pe_status_check--infra_summary--indicator_exclusions"></a>`indicator_exclusions`

Data type: `Array[String[1]]`

List of disabled indicators, place any indicator ids you do not wish to report on in this list
Static Hiera Data can be used to set indicator_exclusions in a plan - for more information see https://www.puppet.com/docs/pe/latest/writing_plans_in_puppet_language_pe.html#using_hiera_with_plans

Default value: `lookup('pe_status_check::indicator_exclusions', undef, undef, [])`

